var dashBoardScp = {};
var globalFuns = {};

// Electron communications
globalFuns.electron = function () {
  function isStageReady(state) {
    // for Web
    examNative.isStageReady(state);
  }

  function getNativeRef(pNative) {
    examNative = pNative;
  }
  // set exam server scope
  function setDashBoardScope(scope) {
    dashBoardScp = scope;
  }
  // send assessmentdata to exam server
  function sendAssessmentData(data) {
    console.log(data);
    dashBoardScp.getAssessmentData(data);
  }
  // update answersheet when student writing live exam
  function updateDBAnswerDocument(answersheet, isEndTest) {
    var parsedSheet = JSON.stringify(answersheet)
    examNative.updateDBAnswerDocument(parsedSheet, isEndTest);
  }
  // send live answersheets data to update in exam server
  function broadcastAnalyticsChange(data) {
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.listenAnalyticsChange(data);
  }
  function submitAssessmentToDB(data) {
    var parsedDoc = JSON.stringify(data);
    examNative.submitAssessmentToDB(parsedDoc);
  }
  // update assessment to enable/disable reveal feedback for students  
  function updateAssessmentInfo(actData, type) {
    var parsedDoc = JSON.stringify(actData);
    examNative.updateAssessmentInfoById(parsedDoc, type);
  }
  // if it is inbox updating last attempted Data & close Assessment popup 
  function closeAssessmentPopup() {
    dashBoardScp.closeAssessmentPopup();
  }
  function setAppLanguage(data){
    // dashBoardScp.setDynamicLanguage(data);
  }

  function getAnswerByQuestionId(inputData){
    var parsedDoc = JSON.stringify(inputData);
    examNative.getAnswerByQuestionId(parsedDoc);
  }
  function sendAnswerByQuestionId(data){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAnswerByQuestionId(data);
  }

  function resetAnswersheetsById(id){
    examNative.resetAnswersheetsById(id);
  }

  function assessmentAnswersheetReport(id){
    examNative.getAssessmentAnswersheetReport(id);
  }

  function sendAssessmentAnswersheetReport(data, isReset){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAssessmentAnswersheetReport(data, isReset);
  }

  window.isStageReady = isStageReady;
  window.getNativeRef = getNativeRef;
  window.setDashBoardScope = setDashBoardScope;
  window.sendAssessmentData = sendAssessmentData;
  window.updateDBAnswerDocument = updateDBAnswerDocument;
  window.broadcastAnalyticsChange = broadcastAnalyticsChange;
  window.submitAssessmentToDB = submitAssessmentToDB;
  window.updateAssessmentInfo = updateAssessmentInfo;
  window.closeAssessmentPopup = closeAssessmentPopup;
  window.setAppLanguage = setAppLanguage;
  window.getAnswerByQuestionId = getAnswerByQuestionId;
  window.sendAnswerByQuestionId = sendAnswerByQuestionId;
  window.resetAnswersheetsById = resetAnswersheetsById;
  window.assessmentAnswersheetReport = assessmentAnswersheetReport;
  window.sendAssessmentAnswersheetReport = sendAssessmentAnswersheetReport;


}


// IOS communications
globalFuns.ios = function () {
  function isStageReady(state) {
    // for Web
    examNative.isStageReady(state);
  }

  function getNativeRef(pNative) {
    examNative = pNative;
  }
  // set exam server scope
  function setDashBoardScope(scope) {
    dashBoardScp = scope;
  }


  // write 'sendToApp()' in this file only
  function sendToApp(_key, _val) {
    var iframe = document.createElement("IFRAME");
    iframe.setAttribute("src", _key + ":##sendToApp##" + _val);
    document.documentElement.appendChild(iframe);
    iframe.parentNode.removeChild(iframe);
    iframe = null;
  }
  // send assessmentdata to exam server -- not using for ios
  function sendAssessmentData(data) {
    console.log(data);
    dashBoardScp.getAssessmentData(data);
  }
  // update answersheet when student writing live exam
  function updateDBAnswerDocument(answersheet, isEndTest) {
    var parsedSheet = JSON.stringify(answersheet);

    if (isEndTest) {
      sendToApp('endtest', parsedSheet); // For IOS
    }
    else {
      sendToApp('updateDBAnswerDocument', parsedSheet);
    }
  }

  // send live answersheets data to update in exam server
  function broadcastAnalyticsChange(data) {
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.listenAnalyticsChange(data);
  }
  function submitAssessmentToDB(data) {
    var parsedDoc = JSON.stringify(data);
    examNative.submitAssessmentToDB(parsedDoc);
  }
  // update assessment to enable/disable revealfeedback/start/end assessment for students  
  function updateAssessmentInfo(actData, type) {
    actData.docUpdType = type;
    var parsedDoc = JSON.stringify(actData);

    sendToApp('updateAssessmentInfoById', parsedDoc);
  }
  // if it is inbox updating last attempted Data & close Assessment popup 
  function closeAssessmentPopup() {
    dashBoardScp.closeAssessmentPopup();
  }
  function setAppLanguage(data){
    // dashBoardScp.setDynamicLanguage(data);
  }

  function getAnswerByQuestionId(inputData){
    var parsedDoc = JSON.stringify(inputData);
    sendToApp('getAnswerByQuestionId', parsedDoc);
  }
  function sendAnswerByQuestionId(data){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAnswerByQuestionId(data);
  }

  function resetAnswersheetsById(id){
    sendToApp('resetAnswersheetsById', id);
  }

  function assessmentAnswersheetReport(id){
    sendToApp('getAssessmentAnswersheetReport', id);
  }

  function sendAssessmentAnswersheetReport(data, isReset){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAssessmentAnswersheetReport(data, isReset);
  }

  window.isStageReady = isStageReady;
  window.getNativeRef = getNativeRef;
  window.setDashBoardScope = setDashBoardScope;
  window.sendAssessmentData = sendAssessmentData;
  window.updateDBAnswerDocument = updateDBAnswerDocument;
  window.broadcastAnalyticsChange = broadcastAnalyticsChange;
  window.submitAssessmentToDB = submitAssessmentToDB;
  window.updateAssessmentInfo = updateAssessmentInfo;
  window.closeAssessmentPopup = closeAssessmentPopup;
  window.setAppLanguage = setAppLanguage;
  window.getAnswerByQuestionId = getAnswerByQuestionId;
  window.sendAnswerByQuestionId = sendAnswerByQuestionId;
  window.resetAnswersheetsById = resetAnswersheetsById;
  window.assessmentAnswersheetReport = assessmentAnswersheetReport;
  window.sendAssessmentAnswersheetReport = sendAssessmentAnswersheetReport;

}


// Android communications
globalFuns.android = function () {

  function isStageReady(state) {
    // for android
    Android.isStageReady(state);
  }

  function getNativeRef(pNative) {
    examNative = pNative;
  }
  // set exam server scope
  function setDashBoardScope(scope) {
    dashBoardScp = scope;
  }
  // send assessmentdata to exam server
  function sendAssessmentData(data) {
    console.log(data);
    dashBoardScp.getAssessmentData(data);
  }
  // update answersheet when student writing live exam
  function updateDBAnswerDocument(answersheet, isEndTest) {
    var parsedSheet = JSON.stringify(answersheet)
    Android.updateDBAnswerDocument(parsedSheet, isEndTest);
  }
  // send live answersheets data to update in exam server
  function broadcastAnalyticsChange(data) {
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.listenAnalyticsChange(data);
  }
  function submitAssessmentToDB(data) {
    var parsedDoc = JSON.stringify(data);
    Android.submitAssessmentToDB(parsedDoc);
  }
  // update assessment to enable/disable reveal feedback for students  
  function updateAssessmentInfo(actData, type) {
    var parsedDoc = JSON.stringify(actData);
    Android.updateAssessmentInfoById(parsedDoc, type);
  }
  // if it is inbox updating last attempted Data & close Assessment popup 
  function closeAssessmentPopup() {
    dashBoardScp.closeAssessmentPopup();
  }
  function setAppLanguage(data){
    // dashBoardScp.setDynamicLanguage(data);
  }

  function getAnswerByQuestionId(inputData){
    var parsedDoc = JSON.stringify(inputData);
    Android.getAnswerByQuestionId(parsedDoc);
  }
  function sendAnswerByQuestionId(data){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAnswerByQuestionId(data);
  }

  function resetAnswersheetsById(id){
    Android.resetAnswersheetsById(id);
  }

  function assessmentAnswersheetReport(id){
    Android.getAssessmentAnswersheetReport(id);
  }

  function sendAssessmentAnswersheetReport(data, isReset){
    if (typeof data == "string") data = JSON.parse(data);
    dashBoardScp.sendAssessmentAnswersheetReport(data, isReset);
  }


  window.isStageReady = isStageReady;
  window.getNativeRef = getNativeRef;
  window.setDashBoardScope = setDashBoardScope;
  window.sendAssessmentData = sendAssessmentData;
  window.updateDBAnswerDocument = updateDBAnswerDocument;
  window.broadcastAnalyticsChange = broadcastAnalyticsChange;
  window.submitAssessmentToDB = submitAssessmentToDB;
  window.updateAssessmentInfo = updateAssessmentInfo;
  window.closeAssessmentPopup = closeAssessmentPopup;
  window.setAppLanguage = setAppLanguage; 
  window.getAnswerByQuestionId = getAnswerByQuestionId;
  window.sendAnswerByQuestionId = sendAnswerByQuestionId;
  window.resetAnswersheetsById = resetAnswersheetsById;
  window.assessmentAnswersheetReport = assessmentAnswersheetReport;
  window.sendAssessmentAnswersheetReport = sendAssessmentAnswersheetReport;

  
}




getCurrentAppPlatform = function () {
  var crtPlatform;
  var userAgt = window.navigator.userAgent.toLowerCase();
  if (userAgt.includes('electron')) {
    crtPlatform = "electron";
  }
  else if (userAgt.includes('android')) {
    crtPlatform = "android";
  }
  else if ((/(ipad|iPad|iPhone|ipod)/gi).test(navigator.appVersion) || window.navigator.platform == 'MacIntel') {
    crtPlatform = "ios";
  }
  return crtPlatform;
}
var appPlatform = getCurrentAppPlatform();
console.log('current platform: ' + appPlatform)
// if (appPlatform) {
//   if (appPlatform == 'electron') globalFuns.electron();
//   else if (appPlatform == 'ios') globalFuns.ios();
//   else if (appPlatform == 'android') globalFuns.android();
// }
if (appPlatform) globalFuns[appPlatform]();
