
var touchtime = 0;

var PrevPageIndex = 0, FlipTimeout
var IsBrowserChrome = navigator.userAgent.toLowerCase().indexOf("chrome") > -1;
function Popup(g, d) {

    var graphic = g,
		master = g.parent().parent(),
		depth = d,
		fold = 1,
		zRot = g.parent().hasClass('page-left') ? 15 : -15,
		timer,
		POPUP_WIDTH = 300;

    init();

    function init() {
        master.bind('pageFolding', function (e) {
            fold = e.originalEvent.per >= 0 ? e.originalEvent.per : 0;
            //console.log(fold);
            setFold();
        });

        setFold();
    }

    function setFold() {
        var points = [];

        // origin
        points[0] = [0, 0, 0];

        // left piece: bottom outside
        points[1] = [-POPUP_WIDTH * Math.cos(degToRad(-180 * fold)), POPUP_WIDTH * Math.sin(degToRad(-180 * fold)), POPUP_WIDTH * Math.sin(degToRad(-15))];

        // right piece: bottom outside
        points[2] = [POPUP_WIDTH * Math.cos(degToRad(-180 * 0)), POPUP_WIDTH * Math.sin(degToRad(-180 * 0)), POPUP_WIDTH * Math.sin(degToRad(-15))];

        // left piece: top inside
        points[3] = [-POPUP_WIDTH * Math.cos(degToRad((-180 * fold) - 90)), POPUP_WIDTH * Math.sin(degToRad((-180 * fold) - 90)), 0];



        var adj = Math.sqrt(Math.pow(POPUP_WIDTH, 2) - Math.pow(POPUP_WIDTH * Math.sin(degToRad(-15)), 2));
        points[1] = [-adj * Math.cos(degToRad(-180 * fold)), adj * Math.sin(degToRad(-180 * fold)), POPUP_WIDTH * Math.sin(degToRad(-15))];
        points[2] = [adj * Math.cos(degToRad(-180 * 0)), POPUP_WIDTH * Math.sin(degToRad(-180 * 0)), POPUP_WIDTH * Math.sin(degToRad(-15))];
        var len = Math.sqrt(Math.pow(points[1][0], 2) + Math.pow(points[1][1], 2) + Math.pow(points[1][2], 2));

        // normalize the vectors
        var normV1 = $V([points[1][0] / len, points[1][1] / len, points[1][2] / len]);
        var normV2 = $V([points[2][0] / len, points[2][1] / len, points[2][2] / len]);
        var normV3 = $V([points[3][0] / len, points[3][1] / len, points[3][2] / len]);

        // calculate the cross vector
        var cross = normV1.cross(normV2);

        // calculate the cross vector's angle from vector 3
        var crossAngle = -radToDeg(cross.angleFrom(normV3)) - 90;

        // transform the shape		
        graphic.css('-webkit-transform', 'translateY(' + depth + 'px) rotateZ(' + zRot + 'deg) rotateX(' + crossAngle + 'deg)');
        graphic.css('-moz-transform', 'translateY(' + depth + 'px) rotateZ(' + zRot + 'deg) rotateX(' + crossAngle + 'deg)');
        graphic.css('transform', 'translateY(' + depth + 'px) rotateZ(' + zRot + 'deg) rotateX(' + crossAngle + 'deg)');
    }

    function degToRad(deg) {
        return deg * Math.PI / 180;
    }

    function radToDeg(rad) {
        return rad * 180 / Math.PI;
    }
}

var popups,
	paperFolding = 'pageFolding',
	curPageIndex,
	timer,
	zoomedIn,
	curSceneScale,
	curRotX,
	curRotY,
	curPer,
	curDir,
	adjustedPer,
	bgColors,
	domTransformProperty,
	cssTransformProperty,
	domTransitionProperty,
	cssTransitionProperty,
	$leftPage,
	$rightPage,
	$document = $(document),
	$window = $(window),
	$body,
	$scene,
	$book,
	$spreads,
	$dragNotice,
	$hotSpots,
	hasTouch,
	hasMotion,
	hasOrientation,
	numTouches,
	rotationEvent,
	dragStartEvent,
	dragMoveEvent,
	dragStopEvent,
	selectionEvent,
	transitionEndEvents = {
	    'WebkitTransition': 'webkitTransitionEnd',
	    'MozTransition': 'transitionend',
	    'OTransition': 'oTransitionEnd',
	    'msTransition': 'MSTransitionEnd',
	    'transition': 'transitionend'
	},
	transitionEndEvent,
	initialOrientation,
	PAGE_TURN_SPEED = 25;







/****************************

	Main

****************************/

function InitBook() {
    curPageIndex = 0;
    curSceneScale = 1;
    curRotX = -15;
    curRotY = 0;
    curPer = adjustedPer = 0;
    zoomedIn = false;
    curRotX = -15;
    numTouches = 0;
    domTransformProperty = Modernizr.prefixed('transform');
    cssTransformProperty = domToCss(domTransformProperty);
    domTransitionProperty = Modernizr.prefixed('transition');
    cssTransitionProperty = domToCss(domTransitionProperty);
    bgColors = ['#3272ad', '#ae0039', '#50326d', '#355506', '#3272ad'];
    $body = $('body');
    $scene = $('.scene');
    $book = $('.book');
    $spreads = $('.spread');
    $dragNotice = $('.drag-notice');
    $hotSpots = $('.hotspot');
    hasTouch = Modernizr.touch;
    hasMotion = Modernizr.devicemotion;
    hasOrientation = Modernizr.deviceorientation;
    rotationEvent = (hasTouch && hasOrientation) ? 'deviceorientation' : 'mousemove';
    dragStartEvent = hasTouch ? 'touchstart' : 'mousedown';
    dragMoveEvent = hasTouch ? 'touchmove' : 'mousemove';
    dragStopEvent = hasTouch ? 'touchend' : 'mouseup';
    selectionEvent = hasTouch ? 'touchend' : 'click';
    transitionEndEvent = transitionEndEvents[domTransitionProperty];
    has3d = Modernizr.csstransforms3d;
	//document.addEventListener('touchstart', function(e) {e.preventDefault()}, { passive: false });
	//document.addEventListener('touchmove', function(e) {e.preventDefault()}, { passive: false });

    if (has3d) {
        craftThatPaperBaby();
        if (hasTouch) {
            hideLocationBar();
            $dragNotice.html('Touch and drag<br />to turn pages!');
            $dragNotice.css({
                'width': '220px'
            });
        }
        $window.bind(rotationEvent, rotateScene);
        $window.bind('resize', resizeScene);
        $body.bind(dragStartEvent, startDrag);
        $hotSpots.bind(selectionEvent, zoomToHotspot);

        resizeScene();
        adjustScene();
    } else {
        $body.addClass('no3d');
    }
    if (MyDir == "rtl") {
        for (var x = 0; x < TheContent.length + 1; x++) updateDrag()
    }
}






/****************************

	Pages

****************************/

function startDrag(e) {
    //e.preventDefault();
    //alert('stop')
    $book.css('cursor', '-webkit-grabbing');
    $scene.data('offset', hasTouch ? e.originalEvent.touches[0].pageX : e.pageX);
    $body.bind(dragMoveEvent, updateDrag);
    $body.bind(dragStopEvent, stopDrag);
}

function updateDrag(e) {
    if (e != null) e.preventDefault();

    if ($dragNotice.hasClass('shown')) {
        $dragNotice.removeClass('shown');
    }

    if (e != null) {
        var targetX = (hasTouch ? e.originalEvent.touches[0].pageX : e.pageX) - $scene.data('offset');
    } else {
        var targetX = -$body.width()
    }
    var per = targetX / $body.width() * 2.5;
    var shouldBreak = false;

    per = clamp(per, -1, 1);

    var dir = per < 0 ? 'left' : 'right';

    if (curPer + per < 0 && adjustedPer > 0) {
        shouldBreak = true;
        curPer = adjustedPer = 0;
        stopDrag();
    } else if (curPer + per > 0 && adjustedPer < 0) {
        shouldBreak = true;
        curPer = adjustedPer = 0;
        stopDrag();
    } else {
        adjustedPer = clamp(curPer + per, -1, 1);
        adjustedPer = Math.round(adjustedPer * 1000) / 1000;
    }
    var absPer = Math.abs(adjustedPer);
    //alert(absPer)
    if ((curPageIndex == 0 && adjustedPer > 0) || (curPageIndex == TheContent.length + 1 && adjustedPer < 0)) {
        stopDrag();
        curPer = adjustedPer = 0;
        return;
    }

    if (absPer != 1 && absPer != 0) {
        $hotSpots.css('pointer-events', 'none');
        //$hotSpots.find('.indicator').css('opacity', '0');
    } else {
        $hotSpots.css('pointer-events', 'auto');
        $hotSpots.find('.indicator').css('opacity', '1');
    }

    var leftTransform;
    var rightTransform;
    if (!shouldBreak) {
        $leftPage = adjustedPer < 0 ? $spreads.eq(curPageIndex) : $spreads.eq(curPageIndex - 1);
        $rightPage = adjustedPer < 0 ? $spreads.eq(curPageIndex + 1) : $spreads.eq(curPageIndex);
        rightTransform = 'rotateY(' + (-180 * (adjustedPer < 0 ? absPer : 1 - absPer)) + 'deg)';
        leftTransform = 'rotateY(' + (180 * (adjustedPer < 0 ? 1 - absPer : absPer)) + 'deg)';
        $leftPage.find('.page-right').css(cssTransformProperty, rightTransform);
        $rightPage.find('.page-left').css(cssTransformProperty, leftTransform);

        $leftPage.trigger(paperFolding, adjustedPer < 0 ? absPer : 1 - absPer);
        $rightPage.trigger(paperFolding, adjustedPer < 0 ? 1 - absPer : absPer);

       toggleVisibles(absPer * 180, adjustedPer < 0 ? curPageIndex : curPageIndex - 1);
    } else {
        rightTransform = 'rotateY(' + (-180 * (dir == 'right' ? absPer : 1 - absPer)) + 'deg)';
        leftTransform = 'rotateY(' + (180 * (dir == 'right' ? 1 - absPer : absPer)) + 'deg)';
        $leftPage.find('.page-right').css(cssTransformProperty, rightTransform);
        $rightPage.find('.page-left').css(cssTransformProperty, leftTransform);

        $leftPage.trigger(paperFolding, dir == 'right' ? absPer : 1 - absPer);
        $rightPage.trigger(paperFolding, dir == 'right' ? 1 - absPer : absPer);

        toggleVisibles(absPer * 180, dir == 'right' ? curPageIndex : curPageIndex - 1);
    }

    $spreads.each(function (i) {
        var anglePerPage = 180 / 9;
        var offsetIndex = adjustedPer < 0 ? 5 + curPageIndex - i : 5 + curPageIndex - i - 2;
        var offsetAngle = adjustedPer < 0 ? offsetIndex - adjustedPer - 1 : offsetIndex - adjustedPer + 1;
        var rads = degToRad(offsetAngle * anglePerPage + 10);
        var tarX = 5 * Math.cos(rads);
        var tarZ = 5 * Math.sin(rads);
        //update
        //		var transform = 'translateX(' + tarX.toFixed(3) + 'px) translateZ(' + tarZ.toFixed(3) + 'px) rotateY(' + (i * 0.5) + 'deg)';

        var transform = 'translateX(' + tarX.toFixed(3) + 'px) translateZ(' + tarZ.toFixed(3) * 10 + 'px) rotateY(' + (i * 0.5) + 'deg)';
        $(this).css(cssTransformProperty, transform);
    });
    var bookTransform;
    if (curPageIndex == 0) {
        bookTransform = 'translateX(' + (-300 + (300 * absPer)) + 'px) rotateX(' + (29 + (61 * absPer)) + 'deg) rotateZ(' + (-8 + (8 * absPer)) + 'deg) translateZ(' + (100 - (100 * absPer)) + 'px)';
    } else if (curPageIndex == 1 && adjustedPer > 0) {
        bookTransform = 'translateX(' + (-300 * absPer) + 'px) rotateX(' + (90 - (61 * absPer)) + 'deg) rotateZ(' + (-8 * absPer) + 'deg) translateZ(' + (100 * absPer) + 'px)';
    } else if (curPageIndex == TheContent.length && adjustedPer < 0) {
        bookTransform = 'translateX(' + (300 * absPer) + 'px) rotateX(' + (90 - (61 * absPer)) + 'deg) rotateZ(' + (-8 * absPer) + 'deg) translateZ(' + (100 * absPer) + 'px) translateY(' + (-120 * absPer) + 'px)';
    } else if (curPageIndex == TheContent.length + 1) {
        bookTransform = 'translateX(' + (300 - (300 * adjustedPer)) + 'px) rotateX(' + (29 + (61 * adjustedPer)) + 'deg) rotateZ(' + (-8 + (8 * adjustedPer)) + 'deg) translateZ(' + (100 - (100 * adjustedPer)) + 'px) translateY(' + (-120 + (120 * adjustedPer)) + 'px)';
    }
    clearTimeout(FlipTimeout);
    FlipTimeout = setTimeout(function () {
        if (PrevPageIndex != curPageIndex) {
            //playsound(CurDir+"flip.mp3")
            var SOUND = soundManager.createSound({ url: CurDir + 'flip.mp3', id: 'flip' }); SOUND.play();
        }
        PrevPageIndex = curPageIndex
    }, 100)

    //
    //


    $book.css(cssTransformProperty, bookTransform);
    if (absPer >= 1) {
        adjustedPer < 0 ? curPageIndex++ : curPageIndex--;
        curPer = adjustedPer = 0;
        stopDrag();
    }
}

function stopDrag(e) {
    curDir = null;
    curPer = adjustedPer;
    $body.unbind(dragMoveEvent);
    $body.unbind(dragStopEvent);
    $book.css('cursor', '-webkit-grab');

}

function toggleVisibles(per, leftIndex) {
    var curPage = $spreads.eq(curPageIndex);
    var nextPage = $spreads.eq(curPageIndex + 1);
    var prevPage = $spreads.eq(curPageIndex - 1);

    var toTurn1;
    var toTurn2;

    if (leftIndex == curPageIndex) {
        toTurn1 = curPage;
        toTurn2 = nextPage;
    } else {
        toTurn1 = curPage;
        toTurn2 = prevPage;
    }

    if (per > 179.5) {
        //update
      //  if (IsBrowserChrome) toTurn1.css({ "visibility": "hidden" })
        toTurn1.find('.popup').hide();
        toTurn1.find('.hotspot').hide();
    } else {
      //  if (IsBrowserChrome) toTurn1.css({ "visibility": "visible" })
        toTurn1.find('.popup').show();
        toTurn1.find('.hotspot').show();
    }

    if (per < 0.5) {
       // if (IsBrowserChrome) toTurn2.css({ "visibility": "hidden" })
        toTurn2.find('.popup').hide();
        toTurn2.find('.hotspot').hide();
    } else {
      //  if (IsBrowserChrome) toTurn2.css({ "visibility": "visible" })
        toTurn2.find('.popup').show();
        toTurn2.find('.hotspot').show();
    }

    if (per > 160) {
        toTurn1.find('.hotspot .indicator').hide();
    } else {
        toTurn1.find('.hotspot .indicator').show();
    }

    if (per < 20) {
        toTurn2.find('.hotspot .indicator').hide();
    } else {
        toTurn2.find('.hotspot .indicator').show();
    }
}








/****************************

	Hotspots

****************************/


function zoomToHotspot(e) {


    if (touchtime == 0) {
        //set first click
        touchtime = new Date().getTime();
    } else
    {
        //compare first click to this click and see if they occurred within double click threshold
        if (((new Date().getTime()) - touchtime) < 200) {
            //double click occurred

            //e.preventDefault();
            //alert(55)
            $body.unbind(selectionEvent);
            $window.unbind(rotationEvent);
            var $spot = $(this);
            var $focusedSpot = $hotSpots.filter('.focused');
            var hotspot = $focusedSpot.length > 0 ? $focusedSpot : $spot;
            var indicator = hotspot.children('.indicator');

            if (zoomedIn) {


                var iOS = (navigator.userAgent.match(/(iPad|iPhone|iPod)/g) ? true : false);
                //alert($(e.target).attr('class'))
                if (!iOS || (iOS && $(e.target).attr('class') == 'indicator')) {

                    if ($(e.target).hasClass("Speaker") || $(e.target).hasClass("Video")) return
                    setTimeout(function (e) {
                        hotspot.removeClass('focused');
                    }, 1);
                    $spreads.show();

                    adjustScene();

                    $body.bind(dragStartEvent, startDrag);

                    setTimeout(function (e) {
                        $scene.css(cssTransitionProperty, 'none');
                        $scene.unbind(domTransitionProperty);
                        $window.bind(rotationEvent, rotateScene);
                    }, 600);
                    soundManager.stopAll();
                    $('.Speaker').removeClass('Playing')
                    //alert(5)
                }

            } else {
                $("body > div.scene > div > ul > li:nth-child(4) > div.page-left.page > div.hotspot.focused > div.indicator").click();

                hotspot.addClass('focused');
                var thisSpread = hotspot.parents('.spread');
                $spreads.not(thisSpread).hide();
                indicator.css({
                    'margin-left': indicator.attr('data-offsetX') + 'px',
                    'margin-top': indicator.attr('data-offsetY') + 'px'
                });

                $body.unbind(dragStartEvent);
                $window.unbind(rotationEvent, rotateScene);
                $body.unbind(dragMoveEvent);

                $scene.css(cssTransitionProperty, 'all .6s');

                setTimeout(function () {
                    $body.bind(selectionEvent, zoomToHotspot);
                }, 1);

                var $spread = $spot.parents('.spread');

                var scale = (1 - ((1 - curSceneScale) * 0.3));
                var scaleTransform = 'scale3d(' + scale + ', ' + scale + ', ' + scale + ')';
                var translateTransform;
                var spreadTransform;
                if ($spread.hasClass('intro')) {
                    translateTransform = 'translateY(-200px) translateX(400px) translateZ(400px) rotateX(-90deg) rotateY(5deg) rotateZ(1deg)';
                } else if ($spread.hasClass('location')) {
                    translateTransform = 'translateY(-150px) translateX(-330px) translateZ(400px) rotateX(-90deg) rotateY(5deg) rotateZ(1deg)';
                } else if ($spread.hasClass('music')) {
                    translateTransform = 'translateY(-200px) translateX(315px) translateZ(400px) rotateX(-90deg) rotateY(5deg) rotateZ(1deg)';
                }
                spreadTransform = scaleTransform + ' ' + translateTransform;
                $scene.css(cssTransformProperty, spreadTransform);
            }

            zoomedIn = !zoomedIn;
            touchtime = 0;
        } else {
            //not a double click so set as a new first click
            touchtime = new Date().getTime();
        }
    }

}










/****************************

	Scenes

****************************/


function rotateScene(e) {
    var o = e.originalEvent;
    var theta = (Math.abs(window.orientation) == 90) ? o.beta : o.gamma;
    curRotY = e.type === 'deviceorientation' ? 0 + (15 * (theta / -45)) : -15 + (30 * e.pageX / $body.width());
    curRotX = -15;

    adjustScene();
}

function adjustScene() {
    var sceneTransform = 'scale3d(' + curSceneScale + ', ' + curSceneScale + ', ' + curSceneScale + ') translateY(100px) rotateX(' + curRotX + 'deg) rotateY(' + curRotY + 'deg)';
    $scene.css(cssTransformProperty, sceneTransform);
}

function resizeScene(e) {
    hideLocationBar();
    var curW = $body.width();
    var curH = $body.height();
    var maxW = 1670;
    var maxH = 725;

    var diffW = curW / maxW;
    var diffH = curH / maxH;

    curSceneScale = diffW < diffH ? diffW : diffH;

    adjustScene();
}










/****************************

	Utilities

****************************/

function degToRad(deg) {
    return deg * Math.PI / 180;
}

function radToDeg(rad) {
    return rad * 180 / Math.PI;
}

function domToCss(property) {
    var css = property.replace(/([A-Z])/g, function (str, m1) {
        return '-' + m1.toLowerCase();
    }).replace(/^ms-/, '-ms-');

    return css;
}

function clamp(val, min, max) {

    if (val > max) return max;
    if (val < min) return min;

    return val;
}





/****************************

	Setup

****************************/


function craftThatPaperBaby() {
    popups = [];
    $('.popup').each(function (i) {
        var $popup = $(this);
        var master = $popup.parents('.spread');
        var depth = $popup.attr('data-depth');
        var popup = new Popup($popup, depth, paperFolding);

        popups.push(popup);
    });

    $spreads.each(function (i) {
        var anglePerPage = 180 / 9;
        var offsetIndex = 5 + curPageIndex - i;
        var offsetAngle = offsetIndex - 1;
        var rads = degToRad(offsetAngle * anglePerPage + 10);
        var tarX = 5 * Math.cos(rads);
        var tarZ = 5 * Math.sin(rads);
        var $spread = $(this);
        //update
        var pageTransform = 'translateX(' + tarX.toFixed(3) + 'px) translateZ(' + tarZ.toFixed(3) * 10 + 'px) rotateY(' + (i * 0.5) + 'deg)';

        $spread.css(cssTransformProperty, pageTransform);
    });
}

function hideLocationBar() {
    if ($body.width() <= 960) {
        $body.css('padding-bottom', '80px');
        setTimeout(function () {
            window.scrollTo(0, 1);
        }, 0);
    }
}

function Popup(graphic, depth, event) {
    if (!event) event = 'pageFolding';
    this.graphic = graphic;
    this.depth = depth;
    this.zRot = graphic.parents('.page').hasClass('page-left') ? 15 : -15;
    this.POPUP_WIDTH = 300;
    this.POPUP_SQUARE = this.POPUP_WIDTH * this.POPUP_WIDTH;
    this.pwsr = this.POPUP_WIDTH * Math.sin(degToRad(-15));
    this.pwsrs = this.pwsr * this.pwsr
    ;

    var onFold = function (e, per) { this.setFold(per); }.bind(this);
    graphic.parents('.spread').bind(paperFolding, onFold);
    this.setFold(1);
}

Popup.prototype.setFold = function (fold) {
    fold = clamp(fold, 0);
    var adj = Math.sqrt(this.POPUP_SQUARE - this.pwsrs);
    var f180 = -180 * fold;
    var f180r = degToRad(f180);
    var f180nr = degToRad((f180) - 90);

    // origin
    var p0 = [0, 0, 0];

    // left piece: bottom outside
    var p1 = [-adj * Math.cos(f180r), adj * Math.sin(f180r), this.pwsr];

    // right piece: bottom outside
    var p2 = [adj, 0, this.pwsr];

    // left piece: top inside
    var p3 = [-this.POPUP_WIDTH * Math.cos(f180nr), this.POPUP_WIDTH * Math.sin(f180nr), 0];


    // normalize the vectors
    var len = Math.sqrt(p1[0] * p1[0] + p1[1] * p1[1] + p1[2] * p1[2]);
    var normV1 = $V([p1[0] / len, p1[1] / len, p1[2] / len]);
    var normV2 = $V([p2[0] / len, p2[1] / len, p2[2] / len]);
    var normV3 = $V([p3[0] / len, p3[1] / len, p3[2] / len]);

    // calculate the cross vector
    var cross = normV1.cross(normV2);

    // calculate the cross vector's angle from vector 3
    var crossAngle = -radToDeg(cross.angleFrom(normV3)) - 90;

    // transform the shape
    var transform = 'translateY(' + this.depth + 'px) rotateZ(' + this.zRot + 'deg) rotateX(' + crossAngle + 'deg)';
    this.graphic.css(cssTransformProperty, transform);
}
/***********************************************************************/
/***********************************************************************/
/***********************************************************************/
function ReadText(TheText, OnFinish) {
    if (TheText == "") return
    var TTS_iframe, IsNew = [true, -1], TheInner = "", TheMP3File = "TTS_" + (new Date()).getSeconds() + "" + (new Date()).getMinutes() + "" + (new Date()).getHours() + "" + (new Date()).getDay() + "" + (new Date()).getMonth() + "" + (new Date()).getYear() + ".mp3"
    TTS_iframe = document.createElement("iframe")
    TTS_iframe.style.position = "absolute"
    TTS_iframe.style.left = 0; TTS_iframe.style.top = 0
    TTS_iframe.style.width = 0; TTS_iframe.style.height = 0
    TTS_iframe.frameBorder = 0
    document.body.appendChild(TTS_iframe)
    var doc = TTS_iframe.contentWindow.document
    TheInner += '<form name="x1" id="x1" method="post" >'
    TheInner += '<input name="TheText" id="TheText" type="text" value="Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercita"/>'
    TheInner += '<input name="TheFile" id="TheFile" type="text" value="xx"/>'
    TheInner += '<input name="Lang" id="Lang" type="text" value="en"/>'
    TheInner += '<input name="x3" type="submit" value="fdf" />'
    TheInner += '</form>'
    doc.open()
    doc.write(TheInner)
    doc.close()
    doc.getElementById("TheText").value = TheText
    doc.getElementById("TheFile").value = TheMP3File
    doc.getElementById("Lang").value = (IsArabic(TheText) == true ? "ar" : "en")
    doc.getElementById("x1").submit()
    var xxx = setInterval(function () {
        try {
            var errr = TTS_iframe.contentWindow.document.body
            if (errr.innerHTML.indexOf("DOne") != -1) {

                //playsound("http://37.216.233.58/TEA/Temp/" + TheMP3File + "?2", OnFinish)
                document.body.removeChild(TTS_iframe)
                clearInterval(xxx)
            }
        } catch (err) {
           // playsound("http://37.216.233.58/TEA/Temp/" + TheMP3File + "?2", OnFinish)
            document.body.removeChild(TTS_iframe)
            clearInterval(xxx)
        }
    }, 100)
}

function PlayMyFile(who, what) {
    soundManager.stopAll();
    var me = $(who), DoPlay = false
    if (me.hasClass("Speaker") == true) {
        if (me.hasClass("Playing") == false) DoPlay = true
        $(".Speaker").removeClass("Playing")
        if (DoPlay == true) {
            if (what.match(/\.(mp3|wav|wma|ogg|mp4)$/i)) {
                var SOUND = soundManager.createSound({ url: what, id: what, onfinish: function () { $(".Speaker").removeClass("Playing") } });
                SOUND.play();

                //playsound(what,function(){$(".Speaker").removeClass("Playing")})
                me.addClass("Playing")
            }
        }
    } else {
        if (me.hasClass("Playing") == false) DoPlay = true
        $(".Video").removeClass("Playing")
        if (DoPlay == true) {
            me.parent().find(".Content").hide()
            me.parent().find(".Content2").show()
        }
    }
}


$document.ready(function () {

    $("body").removeClass("RTL").removeClass("LTR").fadeIn(1000)
    $("body").addClass($.trim(MyDir.toUpperCase()))
    if (MyDir == "rtl") { TheContent = TheContent.reverse() }
    for (var x = 0; x < TheContent.length; x++) {
        var IMG = document.createElement("img")
        IMG.onload = function () { ImageLoaded(this) }
        $("#ToGetDimensions").append(IMG)
        IMG.src = TheContent[x].split(";;")[0]
    }
})
function OpenMee() {
    $("body").removeClass("RTL").removeClass("LTR")
    $("body").addClass($.trim(MyDir.toUpperCase()))
    if (MyDir == "rtl") { TheContent = TheContent.reverse() }
    for (var x = 0; x < TheContent.length; x++) {
        var IMG = document.createElement("img")
        IMG.onload = function () { ImageLoaded(this) }
        $("#ToGetDimensions").append(IMG)
        IMG.src = TheContent[x].split(";;")[0]
    }
}
var CurLoadedImage = 0
function ImageLoaded(who) {
    CurLoadedImage++
    var w = who.width, h = who.height, x = 0, sc
    var idx = $(who).index()
    Dimensions[idx] = []
    //Dimensions[idx][0] = "";Dimensions[idx][1] = ""
    sc = w / h
    if (w > 1200) { w = 1200; h = parseInt(w / sc) }
    if (h > 500 && w <= 1200) {
        h = 500
        w = parseInt(h * sc)
        Dimensions[idx][0] = "left:" + parseInt((1200 - w) / 2) + "px;width:" + (w / 2) + "px;background-size:" + w + "px " + (h) + "px;"
        Dimensions[idx][1] = "background-position:" + (-w / 2) + "px 0px;background-size:" + w + "px " + (h) + "px;"
    } else if (w <= 1200 && h <= 500) {
        x = (1200 - w) / 2
        Dimensions[idx][0] = "background-position:0 bottom;left:" + (x) + "px;width:" + (w / 2) + "px;"
        Dimensions[idx][1] = "background-position:" + (-w / 2) + "px bottom"
    }


    if (CurLoadedImage >= TheContent.length) { BuildTheBook() }

}

var Dimensions = []
function BuildTheBook() {

    var TheBookInner = '<div  onclick="setTimeout(function(){location.reload(true)},100)"  style="width:2.5vw; height:2.5vw; margin:10px; font-size:2.5vw;line-height:4vw; position:absolute; z-index:888888; border:2px solid #ddd; background:rgba(255,255,255,0.6); padding:5px; text-align:center; border-radius:8px; cursor:pointer"><i   onclick="setTimeout(function(){location.reload(true)},100)" class="fa fa-refresh" style="color:#2e55c2" style="line-height:4vw;"></i></div>', Pages = '';

    for (var x = 0; x < TheContent.length; x++) {
        //var VID = TheContent[x].split(";;")[2].indexOf("$$$") != -1
        var SND = TheContent[x].split(";;")[0].replace(/\.(jpg|png|gif)/gi, ".mp3")

        var Info = '<div onclick="PlayMyFile(this,\'' + SND + '\')" MyFile="' + SND + '" class="Speaker" data-offsetX="50" data-offsetY="50" ></div>';
        Info += '<div class="hotspot">';
        //if(VID==true)Info += '<div onclick="PlayMyFile(this)" MyFile="'+TheContent[x].split(";;")[2].split("$$$")[1]+'" class="Video" data-offsetX="50" data-offsetY="50"></div>'
        Info += '<div onclick="soundManager.stopAll();var SOUND = soundManager.createSound({url:CurDir+\'click.mp3\',id:\'click\'});SOUND.play()" class="indicator" data-offsetX="50" data-offsetY="50"></div>'

        Info += '<div class="Content" style="position:relative;width:100%;height:300px;overflow-y:auto"><div class="ImgTitle">' + TheContent[x].split(";;")[1] + "</div>" + TheContent[x].split(";;")[2].split("$$$")[0] + '</div>'
        //if(VID==true)Info += '<div class="Content2" style="display:none;position:relative;width:560px;height:315px;"><iframe width="560" height="315" src="'+TheContent[x].split(";;")[2].split("$$$")[1]+'" frameborder="0" allowfullscreen></iframe></div>'
        Info += '</div>'

        Pages += '<li class="intro spread">' // width>w/2
        Pages += '<div class="page-left page" style="background:' + TheContent[x].split(";;")[6] + '">'
        Pages += '<div class="popup" data-depth="140" style="background-image:url(' + TheContent[x].split(";;")[5] + '.png)"></div>'
        Pages += '<div class="popup" data-depth="300" style="' + Dimensions[x][0] + ';background-image:url(' + TheContent[x].split(";;")[0] + ')"></div>'
        Pages += TheContent[x].split(";;")[3].toLowerCase() == "left" ? Info : ""
        Pages += '<div class="popup" data-depth="460" style="background-image:url(' + TheContent[x].split(";;")[4] + '.png)"></div>'
        Pages += '</div>'
        // backgroundpos > -w/2
        Pages += '<div class="page-right page" style="background:' + TheContent[x].split(";;")[6] + '">'
        Pages += '<div class="popup" data-depth="140" style="background-image:url(' + TheContent[x].split(";;")[5] + '.png)"></div>'
        Pages += '<div class="popup" data-depth="300" style="' + Dimensions[x][1] + ';background-image:url(' + TheContent[x].split(";;")[0] + ')"></div>'
        Pages += TheContent[x].split(";;")[3].toLowerCase() == "left" ? "" : Info
        Pages += '<div class="popup" data-depth="460" style="background-image:url(' + TheContent[x].split(";;")[4] + '.png)"></div>'
        Pages += '</div>'

        Pages += '</li>'
    }

    var BEG = '<li class="cover spread"><div class="page-right page"><div class="MainTitle">' + PageTitle + '</div></div></li>'
    var END = '<li class="back spread"><div class="page-left page" style="text-align:center"><img src="sema1.png" class="Logo"/></div></li>'
    if (MyDir == "rtl") {
        BEG = '<li class="cover spread"><div class="page-right page" style="text-align:center"><img src="sema1.png" class="Logo"/></div></li>'
        END = '<li class="back spread"><div class="page-left page"><div class="MainTitle">' + PageTitle + '</div></div></li>'
    }

    TheBookInner += '<div class="scene">'
    TheBookInner += '<div class="book on-cover">'
    TheBookInner += '<div class="drag-notice shown"></div>'
    TheBookInner += '<ul class="spreads">'
    TheBookInner += BEG
    TheBookInner += Pages
    TheBookInner += END
    //<iframe id="TheQuiz" onload="InjectDataInIframe(this)" class="2Hidden" src="quiz.htm"></iframe>
    TheBookInner += '</ul>'
    TheBookInner += '</div>'
    TheBookInner += '</div>'

    //var TheEnd = ''
    //TheEnd += '<div onclick="OpeniFrameBack(\'edutainment.htm\')" class="ribbon" style="font-size:20px;left:20px;"><i><span><s></s>Edutainment<s></s></span></i></div>'
    //TheEnd += '<div onclick="OpeniFrameBack(\'table.htm\')" class="ribbon" style="font-size:18px;left:130px;"><i><span><s></s>Summary<s></s></span></i></div>'
    //TheEnd += '<div onclick="OpeniFrameBack(\'quiz.htm\')" class="ribbon" style="font-size:16px;left:230px;"><i><span><s></s>Quiz<s></s></span></i></div>'
    //TheBookInner = TheBookInner.replace("#END#",TheEnd)

    $("body").append($(TheBookInner))
    InitBook()

    // Sounds
    playbacksound($.trim(BackgroundMusic))
    if (ReadCaption == true) ReadText($.trim(PageTitle))

    $("#Overlay  .Close").click(function () { $(".scene").fadeIn(); $("#Overlay").animate({ top: "-100%" }) })

}

function OpeniFrameBack(what) {
    $("#Overlay > .Content").html('<iframe id="TheQuiz" onload="InjectDataInIframe(this)" class="2Hidden" src="' + what + '"></iframe>')
    $("#Overlay").animate({ top: "0%" })


}


function InjectDataInIframe(who) {
    who.contentWindow.postMessage(TheContent.join("###"), "*")
    $(".scene").fadeOut()
}

function ToggleMusic(who) {
    who.toggleClass("muted")
    if (who.hasClass("muted") == false) {
        playbacksound(BackgroundMusic)
        who.attr("src", CurDir + "speaker.png")
    } else {
        stopbacksound()
        who.attr("src", CurDir + "mute.png")
    }
}

function IsArabic(what) {
    if ((what.replace(new RegExp(("qwertyuiopasdfghjklzxcvbnm").split("").join("|"), "gi"), "")).length > (what.replace(new RegExp(("Ø¶ØµØ«Ù‚ÙØºØ¹Ù‡Ø®Ø­Ø¬Ø¯Ø´Ø³ÙŠØ¨Ù„Ø§ØªÙ†Ù…ÙƒØ·Ø¦Ø¡Ø¤Ø±Ù„Ø§Ù‰Ø©ÙˆØ²Ø¸").split("").join("|"), "gi"), "")).length) { return true; }
    return false;
}
