
/* 
======================================================== 
script: image3D engine 
author: Gerard Ferrandez - [Ge1doot] 
date: April 16, 2008 
site: http://www.dhteumeuleu.com 
license: CC-BY-NC - do not remove this notice 
======================================================== 
*/ 
var i3D = function() { 
/* ==== private variables and methods ==== */ 
var O = new Array(100); 
var N = 0; 
var scr = false; 
var xm = 0; 
var ym = 0; 
var cx = 0; 
var cy = -2000; 
var cz = 0; 
var zm = 0; 
var cr = 0; 
var nx = 0; 
var ny = 0; 
var nw = 0; 
var nh = 0; 
var cg = false; 
var mo = false; 
var path, FL, FS, Z, omob, hlb; 
/* ===== crossbrowsers events ==== */ 
function addEvent (o, e, f) { 
var r = false; 
if (window.addEventListener) { o.addEventListener(e, f, false); r = true; } 
else if (window.attachEvent) { r = o.attachEvent('on' + e, f); } 
return r; 
} 
/* ===== append HTML Element ==== */ 
function Append (tag, att, css) { 
var object = document.createElement(tag); 
for( var i in att) object[i] = att[i]; 
for( var i in css) object.style[i] = css[i]; 
this.appendChild(object); 
return object; 
} 
/* ===== window resize ==== */ 
function resize () { 
var o = scr; 
for (nx = 0, ny = 0; o != null; o = o.offsetParent) { 
nx += o.offsetLeft; 
ny += o.offsetTop; 
} 
nw = scr.offsetWidth; 
nh = scr.offsetHeight; 
} 
/* ==== cache xbrowser opacity ==== */ 
function initOpacity (o) { 
if (o.filters && o.filters.alpha) { 
o.alpha = o.filters.alpha; 
o.opacity = function (alpha) { this.alpha.opacity = Math.round(alpha); } 
} else { 
o.alpha = o.style; 
o.opacity = function (alpha) { this.alpha.opacity = alpha } 
} 
} 
/* ==== Image3D Constructor ==== */ 
function Image3D (param) { 
var options = param[4] || {}; 
/* ---- image Element ---- */ 
this.img = scr.append('img', { 
'src' : path + param[0], 
'onclick' : this.click, 
'onmouseover' : this.mover, 
'parent' : this ,
'id':param[0].split('.')[0]
} 
); 
this.loaded = false; 
this.X = param[1]; 
this.Y = -param[2]; 
this.Z = param[3]; 
this.SX = options['zx'] || 1; 
this.SY = options['zy'] || this.SX; 
this.xb = 0; 
this.yb = 0; 
this.zb = 0; 
this.ab = 0; 
this.w2D = 0; 
this.h2D = 0; 
this.x2D = 0; 
this.y2D = 0; 
this.r = 0; 
/* ---- link ---- */ 
this.url = options['url'] || false; 
var txt = options['txt'] || ''; 
if (this.url) { 
txt += '<br><span class="texturl">' 
+ this.url.replace('http://','') 
+ '</span>'; 
this.img.style.cursor = 'pointer'; 
} 
this.icss = this.img.style; 
initOpacity(this.img); 
/* ---- text element ---- */ 
if (txt) { 
	this.txt = scr.append('div', { 
		'innerHTML' : txt, 
		'onclick' : this.click, 
		'parent' : this 
	}, 
		{'width' : '1000px'} 
	); 
	this.tp = -10000; 
	this.tf = true; 
	this.tcss = this.txt.style; 
	initOpacity(this.txt); 
} 
O[N++] = this; 
} 
/* ==== prototype images functions ==== */ 
Image3D.prototype = { 
/* ---- hide non moving images ---- */ 
hide : function () { 
//may
	if (this.visible) { 
		this.visible = false; 
		this.img.style.width = '0px'; 
		this.tp = -10000; 
	} 
}, 
/* ---- hide text ---- */ 
txthide : function () { 
	if (this.txtvisible) { 
		this.txtvisible = false; 
		this.txt.style.top = '-10000px'; 
		this.tp = -10000; 
		this.tf = true; 
	} 
}, 
/* ---- images onmouseover ---- */ 
mover : function () { 
var that = this.parent; 
/* ---- hover ---- */ 
if (mo != this) { 
if (mo) mo.style.border = ""; 
mo = this; 
//this.style.border = that.url ? hlb : omob; 
} 
/* ---- start animation text ---- */ 
if (that.tf && Math.abs(zm - cz) < 50) { 
that.tp = 0; 
that.tf = false; 
that.tcss.fontSize = (that.r * nh / FS) + 'px' 
} 
return false; 
}, 
/* ---- images onclick ---- */ 
click : function() {
	//alert()
	//alert(this.parent)
	//setTimeout(function(){	},1000)
	//	dd();
		
	//	setTimeout(function(){
		var that = this.parent; 
		//if(that.Z!=Last_Level){}	
// alert()
		
		if (that.url) { 
		/* ---- jump to hyperlink ---- */ 
		window.location.href = that.url; 
		} 
		// alert(that.Z)
		
		/* ---- go to image ---- */ 
	//		zm = that.Z + 5; 
			var ss = $(this).attr('id');
	
			if(ss!='door'){
				zm = that.Z - 100;
				//setTimeout(function(){
			//		alert(window.parent.Voice)
			//alert($.inArray(ss,skip_this))
			if($.inArray(ss,skip_this)==-1){
				var SOUND = soundManager.createSound({url:window.parent.Voice+'_'+ss+'.mp3',id:ss+'s'});					
				SOUND.play();	
			}
			}
			else{
				zm = that.Z;

				//},1000)				
			}
				
			if(ss!='door')
				setTimeout(function(){zm = 350;},2000)
			cg = true; 
		return false; 
		
			
				
		//},1000)	

}, 
/* ==== main rendering function ==== */ 
display : function () { 
if (this.loaded) { 
/* ---- 3D coordinates ---- */ 
var x = this.X - cx; 
var y = this.Y - cy; 
var z = this.Z - cz; 
/* ---- animate text ---- */ 
if(this.tp > -200) { 
this.txtvisible = true; 
this.tp -= 2; 
this.tcss.left = Math.round(this.x2D + this.w2D * .5 - 500) + 'px'; 
this.tcss.top = (this.y2D + this.tp + this.h2D * .5) + 'px'; 
this.tcss.zIndex = Math.round(10000 - z); 
this.txt.opacity(200 + this.tp); 
} else this.txthide(); 
/* ---- image visible ---- */ 
if (z > 0) { 
/* ---- 3D to 2D transform ---- */ 
this.r = FL / (FL + (z * Z)); 
this.w2D = this.W * this.r * Z * this.SX; 
this.h2D = this.H * this.r * Z * this.SY; 
this.x2D = Math.floor((nw * .5) + (x * this.r * Z) - (this.w2D * .5)); 
this.y2D = Math.floor((nh * .5) + (y * this.r * Z) - this.h2D); 
/* ---- image in screen ---- */ 
if (this.x2D + this.w2D > 0 && this.x2D < nw) { 
this.visible = true; 
/* ---- image is moving ---- */ 
if (this.x2D != this.xb || this.y2D != this.yb || z != this.zb) { 
this.xb = this.x2D; 
this.yb = this.y2D; 
this.zb = z; 
/* ---- html rendering ---- */ 
this.icss.left = this.x2D + 'px'; 
this.icss.top = this.y2D + 'px'; 
this.icss.width = Math.ceil(this.w2D) + 'px'; 
this.icss.height = Math.ceil(this.h2D) + 'px'; 
this.icss.zIndex = Math.round(10000 - z); 
/* ---- fade in/out ---- */ 
var a = Math.max(0, Math.min(100, z)); 
if (a != this.ab) { 
this.ab = a; 
this.img.opacity(a); 
} 
} 
} else this.hide(); 
} else this.hide(); 
} else { 
/* ==== image onload ==== */ 
if (this.img.complete && this.img.width) { 
/* ---- get size image ---- */ 
this.W = this.img.width; 
this.H = this.img.height; 
this.loaded = true; 
this.img.style.visibility = 'visible'; 
} 
} 
} 
} 
/* ==== public methods ==== */ 
return { 
/* ---- initialize script ---- */ 
init : function (container, imagepath, focalLength, zoom, fontSize, onmouseover_border, hyperlink_border, structure) { 
/* ---- container ---- */ 
scr = document.getElementById(container); 
scr.append = Append; 
if (!scr) return false; 
/* ---- init ---- */ 
resize(); 
path = imagepath; 
FL = focalLength; 
FS = fontSize; 
Z = zoom; 
omob = onmouseover_border; 
hlb = hyperlink_border; 
xm = nx - (document.body.offsetWidth) + nw; 
ym = -ny - nh * .5; 
/* ---- camera xy position ---- */ 
addEvent(window.document, 'mousemove', function(e) { 
if(!$('body').hasClass('load')){
	e = e || window.event; 
	xm = nx - (e.clientX * 2) + nw; 
	ym = -ny + (e.clientY * 2) - nh * 2; 
	return false; 
}
}); 
/* ---- image onclick ---- */ 
addEvent(scr, 'click', function() {
/*alert($(scr).attr('id'))
if (!cg) zm = 0; 
cg = false; 
return false; */
}); 
/* ---- window resize ---- */ 
addEvent(window, 'resize', resize); 
/* ---- mouse wheel - camera z position ---- */ 
if (window.addEventListener) scr.addEventListener('DOMMouseScroll', function(e) { 

if (e.preventDefault) e.preventDefault(); 
zm += (e.detail * 40); 
return false; 
}, false); 

scr.onmousewheel = function () { 

zm += (-event.wheelDelta); 
return false; 
} 
/* ---- create objects ---- */ 
for (var i = 0, n = structure.length; i < n; i++) { 
var s = structure[i]; 
var options = s[4]; 
/* ---- repeat ---- */ 
var r = options ? options['repeat'] : false; 
if (r) { 
for (var j = 0, m = r[1]; j < m; j++) { 
var ok = new Image3D(s); 
s[r[0]] += r[2]; 
} 
} else var ok = new Image3D(s); 
} 
/* ---- launch script ---- */ 
setInterval(i3D.run, 16); 
}, 
/* ---- main loop ---- */ 
run : function () { 
/* ---- camera ease ---- */ 
cx -= Math.round((xm + cx) * .01); 
cy += Math.round((ym - cy) * .05); 
cz += Math.round((zm - cz) * .05); 
/* ---- display loop ---- */ 
var i = N; 
while (i--) O[i].display(); 
} 
} 
}(); 