
// create a base group for hangman game
var headRadius = 17,
    svgWidth = 500,
    svgHeight = 400,
    marginTop = 210,
    strokeWidth = 3,
    duration = 2000,
    bodyLength = 80, 
    armX = .5 * bodyLength, //  arms are shorter
    armY = .6 * bodyLength, // 
    legsX = .4 * bodyLength, // legs longer and closer together
    legsY = .7 * bodyLength,
    eyesRadius = headRadius/4,
    eyeSpacing = headRadius/2,
    midPoint = (svgWidth)/ 2.5 - headRadius;

// all variables for the Post and rope 
var baseWidth = 80,
    baseHeight = 10,
    baseOffsetX = 20,
    baseX = midPoint - baseOffsetX - baseWidth, //get x from midpoint of svg
    baseY = svgHeight - baseHeight - marginTop, //get bottom from midpoint head of hangman 
    poleWidth = 30,
    poleHeight = 500,
    poleX = baseX + (baseWidth / 2) - (poleWidth/2),
    poleY = -1*(svgHeight-midPoint) - 20, // rectangle grows downwards 
    beamWidth = 150,
    beamHeight = 25,
    beamX = -20,
    beamY = -140;

// all variables for the rope 
var ropeHeight = 100,
    ropeX = midPoint,
    hangOffset = 81; 

var svg = d3.select("#hangman-container")
          .attr("width", svgWidth)
          .attr("height", svgHeight)
            .append("g")
          .attr("id", "hangman-with-post")
          .attr("transform", 
                "translate(110," + marginTop+ ")"
               );

var hangman = svg.append("g")
                .attr("id", "hangman");
/*addPart(1);
addPart(2);
addPart(3);
addPart(4);
addPart(5);
addPart(6);
addPart(7);
addPart(8);
addPart(9);
addPart(10);*/

// these function build the rope and translate the hangman up and down 
buildPost(svg);
buildRope(svg); 

function buildRope(svg) {
    svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", "4")
    .attr("id", "rope")
    .attr("x1", "-52.5")
    .attr("y1", function() {
          return Number(d3.select("#beam").attr("y")); 
      })
    .attr("x2", "-52.5")
    .attr("y2", "-91");
}


function gameOver(svg) {
  var duration = 2000;
  d3.select("#rope")
    .transition()
      .duration(duration)
      .attr("y2", "-120")
    .ease("elastic");
	    
    d3.select("#hangman")
     .transition()
     .duration(duration)
     .attr("transform", 
           "translate("+ 0 + ",-25)"
          )
    .ease("elastic");
    
    appendDeadEyes(hangman);

    d3.select("#left-eye")
      .transition()
      .duration(duration/5)
      .attr("r",0)
      .remove();
  
    
  d3.select("#right-eye")
    .transition()
    .duration(duration/5)
    .attr("r",0)
    .remove();
}

function appendDeadEyes(hangman) {
  hangman.append("line")
    .style("stroke", "black")
    .style("stroke-width", 2)
    .style("stroke-lineCap", "round")
    .attr("id", "mouth")
    .attr("x1", "-62.0")
    .attr("y1",  "-85")
    .attr("x2", "-56.5")
    .attr("y2",  "-78")		
    .style("opacity",0)
    .transition()
    .duration(duration)
    .style("opacity",1);
  
    hangman.append("line")
    .style("stroke", "black")
    .style("stroke-width", 2)
    .style("stroke-lineCap", "round")
    .attr("id", "mouth")
    .attr("x1", "-56.5")	
    .attr("x2", "-62.0")
    .attr("y1",  "-85")
    .attr("y2",  "-78")
    .style("opacity",0)
    .transition()
    .duration(duration)
    .style("opacity",1);
  
    hangman.append("line")
    .style("stroke", "black")
    .style("stroke-width", 2)
    .style("stroke-lineCap", "round")
    .attr("id", "mouth")
    .attr("x1", "-49.0")
    .attr("y1",  "-85")
    .attr("x2", "-43.5")
    .attr("y2",  "-78")
    .style("opacity",0)
    .transition()
    .duration(duration)
    .style("opacity",1);
  
    hangman.append("line")
    .style("stroke", "black")
    .style("stroke-width", 2)
    .style("stroke-lineCap", "round")
    .attr("id", "mouth")
    .attr("x2", "-49.0")
    .attr("y1",  "-85")
    .attr("x1", "-43.5")
    .attr("y2",  "-78")
    .style("opacity",0)
    .transition()
    .duration(duration)
    .style("opacity",1);   
}

function resetGame(svg) {
    d3.select("#rope")
      .transition()
      .duration(duration)
      .attr("y2", "-91")
  
  d3.select("#hangman")
    .attr("transform", 
           "translate("+ 0 + "," + (hangOffset-40) + ")"
          )
    .remove();
  
   hangman = svg.append("g")
              .attr("id", "hangman");
}

setTimeout(function() {
  //gameOver(svg);
}, 6000);

setTimeout(function() {
//  resetGame(svg); 
}, 14000);

setTimeout(function() {
/*  addPart(1);
  addPart(2);
  addPart(3);
  addPart(4);
  addPart(5);
  addPart(6);
  addPart(7);
  addPart(8);
  addPart(9);
  addPart(10);*/
}, 15000)

// These function build the post 

function buildPost(svg) {
  buildBase(svg);
  buildPole(svg);
  buildBeam(svg);
}

function buildBase(svg) {
  svg.append("rect")
    .attr("x", "-55")
    .attr("y", "80")
    .attr("width", "60")
    .attr("height", "12.7");
}

function buildPole(svg) {
    svg.append("rect")
    .attr("x", "-8")
    .attr("id", "pole")
    .attr("y", "-170")
    .attr("width", "12.7")
    .attr("height", "321.2");
}

function buildBeam(svg) {
    svg.append("rect")
    .attr("id", "beam")
    .attr("x", "-80.5")
    .attr("y", "-158")
    .attr("width", "85")
    .attr("height", "12.7");
}

// below is all code for person drawing make it a class
function addPart(state) {//alert(state)
    switch (state) {
    //draw the head
    case 1: 
        appendHead(hangman); 
		appendRightEye(hangman);
		appendLeftEye(hangman);	
		appendMouth(hangman);	    		
      break;
    case 2:
        appendBody(hangman);
      break;
    case 3:
        appendRightArm(hangman);
      break;
    case 4:
        appendLeftArm(hangman);
      break;
    case 5:
        appendRightLeg(hangman);
      break;
    case 6:
        appendLeftLeg(hangman);
      break;

    case 10:
      console.log("case " + state); 
      break;
    case 11:
      console.log("case " + state);
      break;
    case 12:
      console.log("case " + state);
      break;        
    }
}

/**
* Construct the head of hangman
*/
function appendHead(svg) {
  svg.append("circle")
    .attr("cx", "-53")
    .attr("cy", "-76.5")
    .attr("r", 0)
    .style("stroke", "black") 
    .style("stroke-width", strokeWidth)   
    .style("fill", "none")
    .transition()
      .duration(duration)
      .attr("r", headRadius)
      .ease("elastic");
}

/**
* Append the body to the head 
* and shift down by 2x headRadius
*/
function appendBody(svg) {
  svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", strokeWidth)
    .style("stroke-lineCap", "round")
    .attr("id", "hman-body")
	.style("width", "4")  
	.style("height", "50")  
	.attr("x1", "-54")	
	.attr("y1", "-60")
	.attr("x2", "-54")	
	.attr("y2", "-30")		
    .transition()
      .duration(duration)
      .attr("y2", "-12")
      .ease("elastic");	
}

function appendRightArm(svg) {
  svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", strokeWidth)
    .style("stroke-lineCap", "round")
    .attr("x1", "-53")
    .attr("y1","-60")
    .attr("x2", "-53")
    .attr("y2","-60")
    .transition()
      .duration(duration)
      .attr("x2", "-13")
      .attr("y2", "-20")
      .ease("elastic");  
}

function appendLeftArm(svg) {
    svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", strokeWidth)
    .style("stroke-lineCap", "round")
    .attr("x1", "-56")
    .attr("y1","-60")
    .attr("x2", "-56")
    .attr("y2","-60")
    .transition()
      .duration(duration)
      .attr("x2", "-90")
      .attr("y2", "-20")
      .ease("elastic"); 
}

function appendRightLeg(svg) {
  var bodyStartY = Number(d3.select("#hman-body").attr("y1")); 
  bodyEndY = bodyStartY + bodyLength;
  console.log(bodyStartY);
  svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", strokeWidth)
    .style("stroke-lineCap", "round")
    .attr("x1", "-53")
    .attr("y1","-10")
    .attr("x2", "-53")
    .attr("y2", "-10")
    .transition()
      .duration(duration)
      .attr("x2", "-13")
      .attr("y2", "30")
      .ease("elastic"); 
}

function appendLeftLeg(svg) {
  var bodyStartY = Number(d3.select("#hman-body").attr("y1")); 
  bodyEndY = bodyStartY + bodyLength;
  console.log(bodyStartY);
  svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", strokeWidth)
    .style("stroke-lineCap", "round")
    .attr("x1", "-56")
    .attr("y1","-10")
    .attr("x2", "-56")
    .attr("y2", "-10")
    .transition()
      .duration(duration)
      .attr("x2", "-90")
      .attr("y2", "30")
      .ease("elastic"); 
}

function appendRightEye(svg) {
  svg.append("circle")
    .attr("cx", "-58.5")
    .attr("cy", "-81")
    .attr("id", "right-eye")
    .attr("r", 0)
    .style("stroke", "black") 
    .style("stroke-width", 2)   
    .style("fill", "none")
    .transition()
      .duration(duration)
      .attr("r", 3)
      .ease("elastic");
}

function appendLeftEye(svg) {
  svg.append("circle")
    .attr("cx", "-46")
    .attr("cy", "-81")
    .attr("id", "left-eye")
    .attr("r", 0)
    .style("stroke", "black") 
    .style("stroke-width", 2)   
    .style("fill", "none")
    .transition()
      .duration(duration)
      .attr("r", 3)
      .ease("elastic");
}

function appendMouth(svg) {
  svg.append("line")
    .style("stroke", "black")
    .style("stroke-width", 2)
    .style("stroke-lineCap", "round")
    .attr("id", "mouth")
    .attr("x1", "-54")
    .attr("y1", "-69")
    .attr("x2", "-54")
    .attr("y2", "-69")
    .transition()
      .duration(duration)
      .attr("x1", function() {
          return Number(d3.select(this).attr("x1")) -6; 
      })
      .attr("x2", function() {
          return Number(d3.select(this).attr("x2")) + 6; 
      })
      .ease("elastic");  
}
//	var parts = new Array('Head','Body','RightArm','LeftArm','RightLeg','LeftLeg')	

//setTimeout(function(){$('#Head, #Body, #RightArm, #LeftArm, #RightLeg, #LeftLeg')},1000)
