/*
Grab from github: https://github.com/alexboots/HTML5-drag-and-drop
*/
// References: 
//http://www.html5rocks.com/en/tutorials/dnd/basics/
//  https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/Drag_and_drop
//  https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/Drag_operations#draggableattribute
//  https://developer.mozilla.org/en-US/docs/Web/Guide/HTML/Recommended_Drag_Types

(function() {
  "use strict";
  var dragAndDropModule = function(draggableElements){

    var elemYoureDragging = null
        , dataString        = 'text/html'    
        , elementDragged = null  
        , draggableElementArray = Array.prototype.slice.call(draggableElements) //Turn NodeList into array
        , dragonDrop = {}; //Put all our methods in a lovely object 

        // Change the dataString type since IE doesn't support setData and getData correctly. 
        dragonDrop.changeDataStringForIe = (function () {
            var userAgent = window.navigator.userAgent,
                msie = userAgent.indexOf('MSIE '),       //Detect IE
                trident = userAgent.indexOf('Trident/'); //Detect IE 11

            if (msie > 0 || trident > 0) {
                dataString = 'Text';
                return true;
            } else {
                return false;
            }
        })();

        
        dragonDrop.bindDragAndDropAbilities = function(elem) {
          elem.setAttribute('draggable', 'true');
          elem.addEventListener('dragstart', dragonDrop.handleDragStartMove, false);
          elem.addEventListener('dragenter', dragonDrop.handleDragEnter, false);
          elem.addEventListener('dragover',  dragonDrop.handleDragOver, false);
          elem.addEventListener('dragleave', dragonDrop.handleDragLeave, false);
          elem.addEventListener('drop',      dragonDrop.handleDrop, false);
          elem.addEventListener('dragend',   dragonDrop.handleDragEnd, false);
        };

        dragonDrop.handleDragStartMove = function(e) {
          var dragImg = document.createElement("img");
          dragImg.src = "http://alexhays.com/i/long%20umbrella%20goerge%20bush.jpeg";
          
          elementDragged = this;

          e.dataTransfer.effectAllowed = 'move';
          e.dataTransfer.setData(dataString, this.innerHTML);
          //e.dataTransfer.setDragImage(dragImg, 20, 50); //idk about a drag image 
        };

        dragonDrop.handleDragEnter = function(e) {
          if(elementDragged !== this) {
            this.style.border = "2px dashed #3a3a3a";
          }
        };

        dragonDrop.handleDragOver = function(e) {   
          e.preventDefault();
          e.dataTransfer.dropEffect = 'move';     
        };

        dragonDrop.handleDragLeave = function(e) {
          this.style.border = "2px solid transparent";
        };

        dragonDrop.handleDrop = function(e) {
         if(elementDragged !== this) {
            var data = e.dataTransfer.getData(dataString);
            elementDragged.innerHTML = this.innerHTML;
            this.innerHTML = e.dataTransfer.getData(dataString);
          }
          this.style.border = "2px solid transparent";
		  /**** START ****/
	var new_ = '';
	$('.Boxed span').each(function(){
		
		new_ = new_ + $(this).html();
	})
	alert(new_)


	//alert(new_.toLowerCase()+' -- '+Items[Global-1].split(';;')[0].toLowerCase())
	if(new_.toLowerCase()==Items[Global-1].split(';;')[0].toLowerCase()){
			$('.SplitHere'+Global).css('color','#4b945a');
			$('.SplitHere'+Global).parent().css('z-index','1');
			$('#horizontaltoolbark'+Global).css({'color':'#4b945a'});
			$('Top.SplitHere'+Global).css({'color':'#4b945a',});
			$('.TheCover'+Global).css('display','block');
			$('.ihs_'+Global+' span').show()
			$('.ihs_'+Global).attr('class','Disabled_me')
			
		$('#'+new_.toLowerCase()).css('opacity','1');
		var SOUND = soundManager.createSound({url:CurDir+'snd_true.mp3',id:'true_me',onfinish:function(){
			if($('.Disabled_me').length==Data.length){
				$('.ToShowHolder').hide()
				$('#FeedBack').css('display','block');	
				$('.hotspot_').css('stroke','green');			
			}
			else	
				Click_To_Play();				
		}});	
		SOUND.play();	
		if(Index_Me<(Play_Me.length-1))
			Index_Me++;
		else	
			Index_Me = 0;
			
					
	}
	
		
	/**** END ****/
          e.stopPropagation();
          return false;
        };

        dragonDrop.handleDragEnd = function(e) {
          this.style.border = "2px solid transparent";
        };

        // Actiavte Drag and Dropping on whatever element
        draggableElementArray.forEach(dragonDrop.bindDragAndDropAbilities);
  };

  var allDraggableElements = document.querySelectorAll('.draggable-droppable');
  dragAndDropModule(allDraggableElements);

})();